      PROGRAM STEPCO
C
C     *********************
C     *                   *
C     *    S T E P C O    *
C     *                   *
C     *********************
C
C
C     READS RAW STEP SCAN DATA IN FREE FROMAT,
C     SCALES AND MERGES DIFFERENT DATA RANGES,
C     PERFORMS BACKGROUND AND LORENTZ-POLARISATION CORRECTIONS
C     AND WRITES A BINARY PATTERN FILE (NPOUT,(TAPE14)) AS INPUT FILE
C     FOR THE X-RAY RIETVELD SYSTEM (XRS-82).
C
C     WRITTEN BY CH. BAERLOCHER, INSTITUT FUER KRISTALLOGRAPHIE UND
C     UND PETROGRAPHIE, ETH - ZENTRUM, CH-8092 ZURICH, JANUARY 1979
C     MODIFIED MARCH 82
C
      CHARACTER*1 COL,ITIT,NL
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(40000)
      EQUIVALENCE (P(1),IP(1))
C
C     DEFINE FILE NAMES
C
      NTIN = 5
      NTOUT = 6
      IPROF = 34
      NCODE = 40
      NPOUT = 14

C     SET DEFAULT VALUES
C
      IBS = 10
      IBINF = 0
      ICOL = 80
      INCP = 4
      IPAGE = 0
      IREAD = 0
      IWEIGT = 1
      IPRINT = -1
      IWCOD = 0
      IOLDBG = 0
      LASTC = 0
      LABEL = 0
      LP = 0
      NBDIM = 49
      NBG = 1
      NERO = 0
      NCHAR = 6
      MBG = 1
      ICOUNT = 0
      NS = 1
      NR = 0
      NSB = NS + INCP
      MAXNS = 1
      MAXTC = 10
      NTC = 0
      NOBS = 0
      BSIG = 0.0
      SUMRC = 0.
      SUMSIG = 0.
      SUMC = 0.
      SUMWC = 0.
      SUMWS = 0.
      FAC = 1.
      STEP = 0.
      XLAMDA = 1.54050
      XLPS = 1.0
      THMAX =0
      THMIN = 0.
      POLRA =  .915
      RD = .01745329252
      DO 2 I=1,22000
    2 IP(I) = 0
      DO 3 I = 1,74
    3 ITIT(I) =' '
      DO 4 I=1,10
      THCR(I) = 0.
      THCS(I) = 0.
      THCT(I) = 0.
    4 CONTINUE
      REWIND IPROF
      WRITE(NTOUT,1200) DTE
C
C     READ AND PRINT CONTROL CARDS
C
    5 READ(NTIN,1000,END=990) COL
CTAM  IF(EOF(NTIN)) 990,10
   10 IF(COL(1).EQ.' '.AND.COL(3).EQ.' ') GO TO 30
      LASTC = 0
      IF(COL(1).EQ.'L'.AND.COL(3).EQ.'B')  GO TO 50
      IF(COL(1).EQ.'E'.AND.COL(3).EQ.'D')  GO TO 800
      IF(COL(1).EQ.'F'.AND.COL(3).EQ.'N')  GO TO 990
      CALL FREDA (7,80)
      IF(COL(1).EQ.'S'.AND.COL(3).EQ.'E')  GO TO 100
      IF(COL(1).EQ.'P'.AND.COL(3).EQ.'L')  GO TO 200
      IF(COL(1).EQ.'S'.AND.COL(3).EQ.'A')  GO TO 300
      IF(COL(1).EQ.'B'.AND.COL(3).EQ.'V')  GO TO 500
      IF(COL(1).EQ.'T'.AND.COL(3).EQ.'C')  GO TO 600
      IF(COL(1).EQ.'B'.AND.COL(3).EQ.'R')  GO TO 700
      IF(COL(1).EQ.'W'.AND.COL(3).EQ.'I')  GO TO 650
      IF(COL(1).EQ.'F'.AND.COL(3).EQ.'L')  GO TO 70
      IF(COL(1).EQ.'2'.AND.COL(3).EQ.'H')  GO TO 250
C
C     CONTINUATION CARD
C
C     LASTC = 1    SCALE  CARD
C     = 2    BGVALU CARD
C     = 3    THCORR CARD
C
   30 IF(LASTC.EQ.0)  GO TO 5
      CALL FREDA (4,80)
      IF(LASTC-2) 300,500,600
C
C     LABEL CARD
C
   50 K = 0
      LABEL = 1
      DO 60 I=1,74
      IF(K.GT.0) GO TO 55
      IF(COL(I+6).EQ.' ') GO TO 60
   55 K = K + 1
      ITIT(K) = COL(I+6)
   60 CONTINUE
      WRITE(NTOUT,1205) ITIT
      GO TO 5
C     FILES CARD
C     CHANGE INPUT FILE NUMBER
   70 NTIN = FN(1)
      GO TO 5
C
C     STEPCO CARD
C     ACCEPTED KEY WORDS: PRINT,NOBGRD,LP,COUNT,RBINF,WCODED,OLDBG
C
  100 IF(KL.LE.0)  GO TO 5
      DO 190 I=1,KL
      IF(NL(I,1).EQ.'N') GO TO 150
      IF(NL(I,1).EQ.'L')  GO TO 110
      IF(NL(I,1).EQ.'P')  GO TO 120
      IF(NL(I,1).EQ.'R')  GO TO 130
      IF(NL(I,1).EQ.'W')  GO TO 140
      IF(NL(I,1).EQ.'O')  GO TO 170
      IF(NL(I,1).EQ.'C')  GO TO 160
      GO TO 190
  110 IF(NL(I,2).NE.'P')  GO TO 190
      LP = 1
      FAC = 100.
      GO TO 190
  120 IF(NL(I,3).NE.'I')  GO TO 190
      IPRINT = 0
      GO TO 190
  130 IF(NL(I,2).NE.'B')  GO TO 190
      IBINF = 1
      GO TO 190
  140 IF(NL(I,2).NE.'C')  GO TO 190
  145 IWCOD =1
      GO TO 190
  150 IF(NL(I,3).NE.'B') GO TO 190
  155 MBG = 0
      GO TO 190
  160 IF(NL(I,3).NE.'U')  GO TO 190
      ICOUNT = 1
      GO TO 190
  170 IOLDBG = 1
  190 CONTINUE
C----DETERMINE FORMAT OF STEP SCAN DATA
      IF(IBINF.EQ.1) GO TO 5
      READ(IPROF,1000) COL
      CALL FREDA(1,30)
      IF(KL.NE.0)  GO TO 195
C----ORIGINAL STEP SCAN DATA
      REWIND IPROF
      GO TO 5
C----CODED FILE WITH TITLE
  195 WRITE(NTOUT,1210) COL
C---- WAS THERE A LABEL CARD SUPPLIED
      IF(LABEL.EQ.1)  GO TO 194
C---- NO, USE OLD FILE LABEL
      DO 193 I=1,74
  193 ITIT(I) = COL(I)
C---- IS IT A COUNTS FILE
  194 IF(ICOUNT.EQ.1)  GO TO 5
      ICOL = 36
      READ(IPROF,1170) THMIN,THMAX,STEP
C----ARE THERE ANY BGVALUE CARDS. IF SO, READ AND/OR SKIP
  196 READ(IPROF,1000) COL
      IF(COL(1).EQ.'B')  GO TO 197
      IF(COL(1).EQ.'F')  GO TO 5
C----NO BGVALUE CARDS, BACKSPACE FILE
      BACKSPACE IPROF
      GO TO 5
  197 IF(IOLDBG.EQ.0)  GO TO 196
C----READ BGVALUE CARDS FROM FILE IPROF
      NTIN = IPROF
      CALL FREDA(7,80)
      GO TO 500
C
C     POLRA CARD
C
  200 IF(KN.NE.1)  GO TO 5
      POLRA = FN(1)
      GO TO 5
C
C     2 THETA CARD
C
  250 IF(KN-1)  5,260,255
  255 THMIN = FN(1)
      THMAX = FN(2)
      GO TO 5
  260 THMAX = FN(1)
      GO TO 5
C
C     SCALE FACTOR CARD FOR NEXT RANGE
C
  300 LASTC = 1
      IF(KN) 5,5,310
  310 SCAL = FN(1)
      TMIN = 0.
      TMAX = 180.
      NR = NR + 1
      GO TO (325,320,318,315),KN
  315 TSTEP = FN(4)
      STEP = TSTEP
  318 TMAX = FN(3)
  320 TMIN = FN(2)
      GO TO 330
C----GET START OF NEXT RANGE
  325 READ (IPROF,1000,END=395) (COL(I),I=1,ICOL)
CTAM  IF(EOF(IPROF)) 395,326
  326 CALL FREDA(1,ICOL)
      IREAD = 1
      IF(FN(1)) 325,325,327
  327 TMIN = FN(1)
      GO TO 336
  330 IF(ICOUNT.EQ.1)  GO TO 399
C----READ NEXT RECORD OF STEP SCAN DATA
  331 READ(IPROF,1000,END=390) (COL(I),I=1,ICOL)
CTAM  IF(EOF(IPROF))  390,335
  335 CALL FREDA(1,ICOL)
      IREAD=1
      IF(FN(1).LE.0.0)  GO TO 390
  336 KS = KN/3
      IF(KS)  331,331,340
  340 DO 385 K=1,KN,3
      IF(FN(K).LT.TMIN)  GO TO 385
      IF(FN(K).GT.TMAX)  GO TO 385
  345 IF(FN(K).GT.P(NS))  GO TO 370
      THET = FN(K)-0.01
      DO 355 N=NSB,NS,INCP
      IF(THET.GT.P(N))  GO TO 355
      IF(ABS(P(N)-FN(K)).LT..01)  GO TO 350
      IF(ABS(P(N+INCP)-FN(K)).GE..01)  GO TO 360
      IS = N + INCP
      GO TO 365
  350 IS = N
      GO TO 365
  355 CONTINUE
  360 WRITE(NTOUT,1050) FN(K)
      NERO = NERO + 1
      GO TO 330
  365 WRITE(NTOUT,1055) NR,FN(K),P(IS)
      NS = IS
      GO TO 380
  370 NS = NS + INCP
      IF(P(NS).LE.0.)  GO TO 380
      IF(ABS(FN(K)-P(NS)).LT.0.01)  GO TO 380
      IF(FN(K).GT.P(NS)) GO TO 370
      NS = NS - INCP
  380 P(NS) = FN(K)
      P(NS+1) = P(NS+1) + FN(K+1)*SCAL
      P(NS+2) = P(NS+2) + FN(K+2)*SCAL
      IP(NS+3) = IP(NS+3) + 1
  385 CONTINUE
      GO TO 331
  390 IF(TMAX.GT.P(NS)) TMAX = P(NS)
      WRITE(NTOUT,1060) NR,TMIN,TMAX,SCAL
      MAXNS = MAX0(MAXNS,NS)
      GO TO 5
  395 WRITE(NTOUT,1180)  IPROF
      GO TO 5
C     SCALE DATA (ONLY COUNTS GIVEN ON FILE IPROF)
  399 P(NS) = TMIN
      IREAD = 2
  400 READ(IPROF,1000,END=440) COL
CTAM  IF(EOF(IPROF)) 440,405
  405 CALL FREDA (1,80)
      IF(KN) 400,400,410
  410 DO 415 N=1,KN
      P(NS+1) = FN(N) * SCAL
      P(NS+2) = SQRT(FN(N)) * SCAL
      NS = NS + 3
  415 P(NS) = P(NS-3) + TSTEP
      GO TO 400
  440 NS = NS - 3
      MAXNS =NS
      INCP = 3
      GO TO 390
C
C     BGVALUE CARD
C
  500 NBG = NBG + 1
      LASTC = 2
      IF(NBG.GT.NBDIM) GO TO 530
      BTHET(NBG) = FN(1)
      BCOUNT(NBG) = FN(2)
      IF(KN.LE.2)  GO TO 510
      BSIGMA(NBG) = FN(3)
      GO TO 515
  510 BSIGMA(NBG) = SQRT(ABS(BCOUNT(NBG)))
  515 IF(NBG.LE.2)  GO TO 5
      IF(BTHET(NBG).GT.BTHET(NBG-1))  GO TO 5
      NBG1 = NBG - 1
      IF(IOLDBG.NE.0.AND.NTIN.NE.IPROF) GO TO 516
      WRITE(NTOUT,1010) NBG1,BTHET(NBG),BTHET(NBG1)
  516 BTH= BTHET(NBG)
      BCNT = BCOUNT(NBG)
      BSIG = BSIGMA(NBG)
      DO 520 N=1,NBG1
      NN = NBG-N
      IF(BTHET(NN).LE.BTH)  GO TO 525
      BCOUNT(NN+1) = BCOUNT(NN)
      BSIGMA(NN+1) = BSIGMA(NN)
  520 BTHET(NN+1) = BTHET(NN)
      WRITE(NTOUT,1070)
      WRITE(NTOUT,1020) COL
  525 BTHET(NN+1) = BTH
      BCOUNT(NN+1) = BCNT
      BSIGMA(NN+1) = BSIG
      GO TO 5
  530 WRITE(NTOUT,1045) NBDIM
      NERO = NERO + 1
      GO TO 5
C
C     THCOR CARD
C
  600 LASTC = 3
      IF(KN-3) 750,605,605
  605 NTC = NTC + 1
      IF(NTC-MAXTC) 610,610,630
  610 THB(NTC) = FN(1)
      THE(NTC) = FN(2)
      IF(KN-4) 625,620,615
  615 THCT(NTC) = FN(5)
  620 THCS(NTC) = FN(4)
  625 THCR(NTC) = FN(3)
      GO TO 5
  630 WRITE(NTOUT,1065) MAXTC
      NERO = NERO + 1
      GO TO 5
C
C     WEIGHT CARD
C
  650 IF(KN-1) 750,5,655
  655 IWEIGT = FN(1) + 1.
      DO 660 K = 2,KN
  660 WGHT(K-1) = FN(K)
      GO TO 5
C
C     BGRND CARD
C
  700 IF(KN.NE.1) GO TO 5
      IBS = FN(1)
      MBG = 1
      GO TO 5
C
C     ERROR ON CARD
C
  750 WRITE(NTOUT,1040)
      WRITE(NTOUT,1020) COL
      NERO = NERO + 1
      GO TO 5
C
C     END CARD
C
  800 IF(NERO.GT.0)  GO TO 995
C----DID WE READ PROFILE DATA
      IF(IREAD.EQ.1)  GO TO 805
C----DID WE READ COUNTS FILE
      IF(IREAD.EQ.2) GO TO 833
C----DO WE READ BINARY PROFILE FILE
      IF(IBINF.EQ.0) GO TO 801
      CALL RBINF(IPROF)
      GO TO 845
C----READ SCALED CODED FILE
  801 READ(IPROF,1000,END=804) (COL(I),I=1,ICOL)
CTAM  IF(EOF(IPROF)) 804,802
  802 CALL FREDA(1,ICOL)
      P(NS) = FN(1)
      P(NS+1) = FN(2)
      P(NS+2) = FN(3)
      NS = NS + 3
      GO TO 801
  804 INCP = 3
      MAXNS = NS - 3
      GO TO 845
C----CORRECT OVERLAPPING REFLECTIONS AND COMPRESS
  805 I = -2
      DO 820 N=5,MAXNS,4
      I = I + 3
      P(I) = P(N)
      IF(IP(N+3)) 815,815,810
  810 FI = FLOAT(IP(N+3))
      P(I+1) = P(N+1)/FI
      P(I+2) = P(N+2)/(SQRT(FI) * FI)
      GO TO 820
  815 P(I+1) = P(N+1)
      P(I+2) = P(N+2)
  820 CONTINUE
      MAXNS = I
      INCP = 3
      IF(STEP.GT.0.)  GO TO 833
C---- GET STEP LENGHT FROM FIRST TWO OBSERVATIONS
      T1 = P(4) - P(1)
      T2 = P(7) - P(4)
      IF(T2-T1) 825,825,830
  825 STEP = T2
      GO TO 835
  830 STEP = T1
  835 I = STEP * 100. + .5
      STEP = FLOAT(I)/100.
  833 IF(THMIN.GT.0.)  GO TO 840
      THMIN = P(1)
  840 IF(THMAX.GT.0.)  GO TO 845
      THMAX = P(MAXNS)
  845 IF(NBG.LE.1)  GO TO 860
      MBG = 0
      NBG = NBG + 1
      BTHET(1) = THMIN - STEP
      BTHET(NBG) = THMAX + 1.
      BCOUNT(1) = (BCOUNT(3)-BCOUNT(2))/(BTHET(3)-BTHET(2))
      BCOUNT(1) = BCOUNT(1) * (BTHET(1)-BTHET(2)) + BCOUNT(2)
      BCOUNT(NBG) = (BCOUNT(NBG-1)-BCOUNT(NBG-2))/(BTHET(NBG-1)-
     $              BTHET(NBG-2))
      BCOUNT(NBG) = BCOUNT(NBG)*(BTHET(NBG)-BTHET(NBG-1))+BCOUNT(NBG-1)
      BSIGMA(1) = 1.5*BSIGMA(2)
      BSIGMA(NBG) = 1.5*BSIGMA(NBG-1)
C
C----WRITE OUT INPUT DATA
C     BACKGROUND CORRECTION
  855 WRITE(NTOUT,1110)
      GO TO 875
  860 IF(MBG) 865,865,870
  865 WRITE(NTOUT,1115)
      GO TO 880
  870 CALL BGRND
      WRITE(NTOUT,1120) IBS
  875 WRITE(NTOUT,1125) (BTHET(I),BCOUNT(I),BSIGMA(I),I=1,NBG)
C
C----APPLY 2 THETA CORRECTION IF REQUIRED
  880 IF(NTC)  885,885,890
  885 WRITE(NTOUT,1130)
      GO TO 900
  890 CALL THCORR
C----OUTPUT PROFILE
  900 WRITE(NPOUT,1000) ITIT
      WRITE(NPOUT,2001) THMIN,THMAX,STEP
 2001 FORMAT(3F10.4)
      IF(IWCOD.EQ.0) GO TO 902
      WRITE(NCODE,1000) ITIT
      KT = 3
      WRITE(NCODE,1170) THMIN,THMAX,STEP,KT
C----WRITE BG VALUES IF PRESENT
      IF(NBG.LE.1) GO TO 902
      N = NBG - 1
      WRITE(NCODE,1126) (BTHET(I),BCOUNT(I),BSIGMA(I),I=2,N)
      WRITE(NCODE,1127)
  902 BGR = BG(1,1,BSIG)
      DO 925 N = 1,MAXNS,INCP
      IIII=N
      IF(P(IIII).LT.THMIN)  GO TO 925
      IF(P(IIII).GT.THMAX)  GO TO 5
      BGR = BG(2,N,BSIG)
      COUNT = P(IIII+1) - BGR
      SIGM = P(IIII+2) + BSIG
C----PERFORM LP CORRECTION IF DESIRED
      IF(LP.EQ.0)  GO TO 905
      ATHET = P(IIII) * RD
      XLP = XLPFAC(ATHET)
      XLPS = XLP * FAC
      COUNT = COUNT * XLPS
      SIGM  = SIGM * SQRT(XLPS)
c  905 W = WEIGHT(IWEIGT)
  905 W = WEIGHT(IWEIGT,COUNT,sigm,iiii+1)
      RSIG = 1./SIGM
      NOBS = NOBS + 1
      RC = RSIG*COUNT
      SUMRC = SUMRC + RC*RC
      SUMSIG = SUMSIG + SIGM
      WC = W * COUNT
      SUMWC = SUMWC + WC * WC
      WS = W * SIGM
      SUMWS = SUMWS + WS * WS
      SUMC = SUMC + COUNT
      WRITE(NPOUT,2002) P(IIII),COUNT,W,RSIG
 2002 FORMAT(F9.4,F9.0,2F11.5)
C----DO WE PRINT THE FILE
      IF(IPRINT)  920,910,915
C----WRITE HEADING
  910 IPAGE = IPAGE + 1
      WRITE(NTOUT,1140) ITIT,DTE,IPAGE
      IPRINT = 57
  915 WRITE(NTOUT,1145) P(IIII),P(IIII+1),BGR,XLPS,COUNT,SIGM,RSIG,W
      IPRINT = IPRINT - 1
C----DO WE WRITE A CODED FILE
  920 IF(IWCOD.EQ.0) GO TO 925
      WRITE(NCODE,1160)  P(IIII),P(IIII+1),P(IIII+2),BGR
  925 CONTINUE
C----CALCULATE EXPECTED R VALUES
      R1 = SQRT(FLOAT(NOBS)/SUMRC)
      R2 = SQRT(SUMWS/SUMWC)
      R3 = SUMSIG/SUMC
      WRITE(NTOUT,1150) NOBS,SUMRC,R1,SUMWS,SUMWC,R2,SUMSIG,SUMC,R3
      GO TO 5
C
C     TERMINATE PROGRAM (FINISH CARD)
C
  990 WRITE(NTOUT,1030) COL
      GO TO 999
  995 WRITE(NTOUT,1090) NERO
  999 STOP
C
C     LIST OF FORTRAN FORMATS
C
 1000 FORMAT(80A1)
 1001 FORMAT(1x,80A1)
 1010 FORMAT(1x,3H***,' ATTENTION: 2 THETA OF BACKGROUND CARD NO.',I3,
     $ ' OUT OF SEQUENCE',/1x,16X,'2THETA IS',F7.2,' THE PREVIOUS VALUE
     $ WAS',F7.2)
 1020 FORMAT(1x,'CARD IMAGE: ',80A1)
 1030 FORMAT(//1x,3H***,80A1)
 1040 FORMAT(1x,'ERROR ON INPUT CARD ')
 1045 FORMAT(1x,'---- DIMENSION CHECK: MORE THAN',I3,' BGVALUE CARDS')
 1050 FORMAT(1x,'OVERLAPPING RANGES: 2THETA MISMATCH FOR RANGE STARTING
     $ ','WITH 2THETA = ',F7.2)
 1055 FORMAT(1x,'OVERLAPPING RANGES: RANGE NO',I3,' STARTING AT 2THETA =
     $ ',F7.2,' IS MERGED WITH EXISTING 2THETA =',F7.2)
 1060 FORMAT(1x,'RANGE NO',I3,' GOING FROM 2THETA =',F7.2,' TO',F7.2,
     $' HAS BEEN SCALED WITH A FACTOR OF',F8.4)
 1065 FORMAT(1x,3H***,' DIMENSION CHECK: NUMBER OF THCORR CARDS EXCEEDS
     $LIMITS OF',I3)
 1070 FORMAT(1x,'----ERROR IN 2 THETA ON BGVALUE CARD ')
 1090 FORMAT(1x,3H***,I3,' INPUT ERROR(S), TERMINATE JOB')
 1110 FORMAT(1x,'BACKGROUND CORRECTION READ FROM CARDS')
 1115 FORMAT(1x,'NO BACKGROUND CORRECTION APPLIED')
 1120 FORMAT(1x,'BACKGROUND DETERMINED BY PROGRAM'/
     $1x,'EACH BG COUNT IS AN AVERAGE OVER',I3,' SUCCESSIVE STEPS')
 1125 FORMAT(1x,6X,'2 THETA',8X,'COUNTS',7X,'SIGMA',
     $ //(1X,F12.2,F14.2,F12.2))
 1126 FORMAT('BGVALU',4X,F10.2,F10.0,F10.2)
 1127 FORMAT('FILES    5')
 1130 FORMAT(1x,'NO 2 THETA CORRECTION APPLIED')
 1140 FORMAT(1x,'STEPCO',5X,74A1,' DATE: ',9A1,5X,'PAGE',I4/1x,
     $'2 THETA    Y(OBS)  BGRND   LP',1H*,'SC   Y(COR)  SIGMA    1/SIGM
     $A    WEIGHT'/)
 1145 FORMAT(1x,F9.4,F9.0,F7.0,F8.3,F9.0,F7.0,2F11.5)
 1150 FORMAT(/1x,'EXPECTED R-VALUES'/57X,'NUMERATOR   DENOMINATOR    R'/
     $1x,3X,47HR1 = SQRT(FLOAT(NOBS)/SUM(((1./SIG)*COUNT)**2)),
     $  4X,I11,F13.1,F8.3/
     $1x,3X,40HR2 = SQRT(SUM(W*SIG**2)/SUM(W*COUNT**2)),11X,F11.1,F13.1,
     $F8.3/1x,3X,25HR3 = SUM(SIGM)/SUM(COUNT),26X,F11.1,F13.1,F8.3)
 1160 FORMAT(F10.5,F12.0,F12.2,F12.3)
 1170 FORMAT(3F10.4,I5)
 1171 FORMAT(1x,3F10.4,I5)
 1180 FORMAT(1x,'END OF FILE ENCOUNTERED ON UNIT NO',I3,' (STEP SCAN DAT
     $A)')
 1200 FORMAT(1x,'STEP SCAN DATA CORRECTION',67X,'DATE ',9A1/1X,25(1H*)//
     $/)
 1205 FORMAT(1x,'TITLE FOR THIS JOB: ',74A1//)
 1210 FORMAT(1x,'INPUT DATA ARE FROM FILE WITH LABEL: ',80A1)
      END
      SUBROUTINE WAVLEN (NTHET)
C
C     SUBROUTINE TO DETERMINE CRYSTAL SYSTEM AND WAVE-LENGTH
C
      CHARACTER*1 COL,NL,NALPHA,LAMDA,ITIT
      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(1)
      EQUIVALENCE (P(1),IP(1))
C
C     DETERMINE WAVE-LENGTH
C
      NALPHA = NL(1,3)
      LAMDA = NL(1,1)
      IF (LAMDA .NE.'C') GO TO 11
      AL1=1.54050
      AL2=1.54434
      GO TO 10
   11 IF (LAMDA .NE. 'F') GO TO 12
      AL1=1.93597
      AL2=1.93991
      GO TO 10
   12 IF (LAMDA .NE. 'M') GO TO 13
      AL1=0.70926
      AL2=0.71354
      GO TO 10
   13 IF((LAMDA.EQ.'E') .AND. (KN .GE. 1))  GO TO 15
      GO TO 14
   10 XLAMDA = AL1
      IF (NALPHA .EQ.'-') XLAMDA=(2.0*AL1 + AL2) / 3.0
      GO TO 16
   14 WRITE(NTOUT,100)
  100 FORMAT(1x,'----- WAVELENGTH IS INCORRECT')
      NERO = NERO + 1
   15 XLAMDA = FN(1)
      NTHET = 2
   16 RETURN
      END
      SUBROUTINE  FREDA(IMIN,IMAX)
c     INTEGER  FL
      CHARACTER*1 COL,IPLUS,IMINUS,IPOINT,IBLANK,INUM,ICH,NL
      COMMON /FR/   COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      DIMENSION INUM(10)
      DATA IPLUS,IMINUS,IPOINT,IBLANK/'+','-','.',' '/
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
      FN(1)=0
      KN=0
      KL=0
      I=IMIN-1
C
C**** START OF A NEW FIELD
C**** LOOK FOR A NON-BLANK COLUMN
C
  109 A=0.0
      IP=0
      NP=0
      L=0
      S=1.0
  110 I=I+1
      IF(I.GT.IMAX)  GO TO 108
  111 ICH=COL(I)
      IF(L.EQ.0  .AND.  ICH.EQ.IBLANK)  GO TO 110
C**** START OF A FIELD
      L=L+1
      DO 100 J=1,10
      IF(ICH.EQ.INUM(J)) GO TO 101
  100 CONTINUE
      IF(ICH.EQ.IPOINT)  GO TO 102
      IF(ICH.EQ.IPLUS)  GO TO 103
      IF(ICH.EQ.IMINUS)  GO TO 104
      IF(L.GT.1)  GO TO 105
      GO TO 150
C**** START OF A LITERAL FIELD BY A CHARACTER WHICH IS OTHER THAN 0-9+-.
C
C**** NUMERIC FIELD FOUND
C
  101 IF(J.EQ.10)  J=0
      IF(IP.EQ.1)  NP=NP+1
  106 A=10.0*A + J
      GO TO 110
  102 IP=1
      GO TO 110
  103 IF(L.GT.1)  GO TO 105
      S=1.0
      GO TO 110
  104 IF(L.GT.1)  GO TO 105
      S=-1.0
      GO TO 110
  108 IF(L.GT.0)  GO TO 105
      GO TO 120
C**** END OF NUMERIC FIELD
  105 A = S*A/10.0**NP
      KN=KN+1
      FN(KN)=A
      IF(ICH.EQ.IPLUS .OR. ICH.EQ.IMINUS)   I=I-1
      GO TO 109
C
C**** LITERAL FIELD
C
  150 KL=KL+1
  151 NL(KL,L) = ICH
      L=L+1
      IF(L.GT.NCHAR)  GO TO 109
      I=I+1
      IF(I.GT.IMAX)  GO TO 152
      ICH=COL(I)
      IF(ICH.EQ.IBLANK)  GO TO 152
      GO TO 151
C**** END OF LITERAL FIELD DEFINED BY BLANK
  152 DO 153 J=L,NCHAR
  153 NL(KL,J) = IBLANK
      GO TO 109
C
C**** FINISHED
C
  120 RETURN
      END
      SUBROUTINE BGRND
C
C     PURPOSE: DETERMINATION OF BACKGROUND
C     METHOD:  THE PROFILE IS DIVIDED IN DIFFERENT RANGES.  EACH
C     RANGE IS SEARCHED FOR IBS SUCCESSIVE MEASUREMENTS WHICH
C     HAVE THE LOWEST SUM. THESE SUMS CONSTITUTE THE RAW BACKGR
C     WHICH IS SMOOTHED. VALUES WHICH DEVIATE APPRECIABLY FROM
C     THE SMOOTHED CURVE ARE DISCARDED AND THE SMOOTHING
C     PROCEDURE REPEATED. THE FINAL SMOOTHED CURVE IS STORED.
C
	CHARACTER*1 ITIT
	
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(1)
      EQUIVALENCE (P(1),IP(1))
      DIMENSION BTH(100),BCNT(100),BSIG(100),BSM(100),TH(400),CNT(400),
     $          SIG(400),BC(100)
      NBDIM = 49
      NS = 0
      NSB = 1
      NB = 0
      ISM = 0
      NBE = IBS
      IEND = 0
      NSTEP = 20
      IF(IBS.GE.NSTEP) NSTEP = IBS + 1
      NP = 1 - INCP
      ISTEP = NSTEP
      GO TO 20
   10 IF(NB.GE.25)  GO TO 14
      IF(NB.GE.15)  GO TO 12
      NSTEP = 100
      GO TO 20
   12 NSTEP = 200
      GO TO 20
   14 NSTEP = 400
C
C     INPUT PROFILE STEPS
C     THE WIDTH OF THE RANGES ARE AS FOLLOWS:
C     20 MEASUREMENTS FOR THE FIRST BG POINT.
C     100 MEASUREMENTS (= 2 DEG. 2 THETA) FOR THE NEXT 14 POINTS.
C     200 MEASUREMENTS FOR THE NEXT 10 POINTS.
C     400 MEASUREMENTS FOR THE REMAINING BG POINTS.
C
   20 ISTEP = NSTEP - NSB
      DO 25 I=1,ISTEP
      NP = NP + INCP
      IF(NP.GT.MAXNS)  GO TO 30
      NS = NS + 1
      TH(NS) = P(NP)
      CNT(NS) = P(NP+1)
      SIG(NS) = P(NP+2)
   25 CONTINUE
      IF(NB) 50,50,60
   30 IEND = 1
      IF(NS.GT.10*IBS)  GO TO 60
      GO TO 200
C
C     FIND LOWEST SUM IN THIS RANGE
C
   50 SBGN = 0
      NB = NB + 1
      BTHET(1) = TH(1) - STEP
      DO 55 I = 1,IBS
   55 SBGN = SBGN + CNT(I)
   60 SBGO = SBGN
      NST = NS
      NSB = IBS + 1
      NB = NB + 1
      NBE = IBS
      DO 65 I = NSB,NST
      SBGN = SBGN - CNT(I-IBS) + CNT(I)
      IF(SBGN.GT.SBGO) GO TO 65
      NBE = I
      SBGO = SBGN
   65 CONTINUE
C
C     GET POSITION, COUNTS AND TRUE SIGMA
C
      NBS = NBE - IBS + 1
      BTH(NB) = (TH(NBS) + TH(NBE)) * .5
      BCNT(NB) = SBGO/FLOAT(IBS)
      SUMSIG = 0.
      SUMCT = 0.
      DO 70 I=NBS,NBE
      SUMSIG = SUMSIG + SIG(I)*SIG(I)
   70 SUMCT = SUMCT + CNT(I)*CNT(I)
      BGS = SUMCT-SBGO*SBGO/FLOAT(IBS)
C     REJECT IF DEVIATIONS WITHIN THIS GROUP ARE TOO LARGE
      IF(BGS.LT.5.*SUMSIG)  GO TO 75
      NB = NB - 1
      GO TO 85
   75 BSIG(NB) = SQRT(BGS/FLOAT(IBS-1))
      IF(NB.LE.2)  GO TO 85
      DIFF = 2.*FLOAT(IBS)*STEP
      IF(BTH(NB)-BTH(NB-1).GT.DIFF)  GO TO 85
C
C     TWO BG MEASUREMENTS ARE CLOSE TOGETHER
C     OMIT LARGER ONE
C
      IF(BCNT(NB).GT.BCNT(NB-1)) GO TO 80
      BCNT(NB-1) = BCNT(NB)
      BTH(NB-1) = BTH(NB)
      BSIG(NB-1) = BSIG(NB)
   80 NB = NB - 1
C
C     SAVE LAST IBS STEPS
C
   85 NS1 = NST-IBS + 1
      NS = 0
      DO 90 N = NS1,NST
      NS = NS + 1
      TH(NS) = TH(N)
      CNT(NS) = CNT(N)
   90 SIG(NS) = SIG(N)
      IF(IEND.EQ.1) GO TO 200
      GO TO 10
C
C     SMOOTH BACKGROUND CORRECTION
C
  200 ISM = ISM + 1
      IS = 0
      NBT = NB - 2
      NBG = NB
      IF(NBT.LE.4)  GO TO 250
      DO 205 I=2,NBG
  205 BC(I) = BCNT(I)
  210 IS = IS + 1
      DO 215 I=4,NBT
      BSM(I) = (34.*BC(I)+24.*(BC(I-1)+BC(I+1))
     $         -6.*(BC(I-2)+BC(I+2)))/70.
  215 CONTINUE
      DIFFB4 = BC(4) - BSM(4)
      BSM(3) = BC(3) + 2./3. * DIFFB4
      BSM(2) = BC(2) - 1./6. * DIFFB4
      DIFFB4 = BC(NBT) - BSM(NBT)
      BSM(NBT+1) = BC(NBT+1) + 2./3. * DIFFB4
      BSM(NBT+2) = BC(NBT+2) - 1./6. * DIFFB4
      IF(IS.EQ.4)  GO TO 217
      DO 216 I = 2,NBG
  216 BC(I) = BSM(I)
      GO TO 210
C
C     REJECT BAD VALUES
C
  217 LBG = 0
      NB = 1
      DO 225 I = 2,NBG
      IF(BCNT(I).LT.(BSM(I) + BSIG(I)))  GO TO 220
      LBG = LBG + 1
      GO TO 225
  220 NB = NB + 1
      BCNT(NB) = BCNT(I)
      BTH(NB) = BTH(I)
      BSIG(NB) = BSIG(I)
  225 CONTINUE
      NBG = NB
      IF(LBG.EQ.0)  GO TO 250
      IF(ISM.LE.4) GO TO 200
  250 IF(NBG.LE.NBDIM) GO TO 255
      WRITE(NTOUT,2000) NBDIM,BTH(NBDIM-1)
      BSM(NBDIM) = BSM(NBG)
      BTH(NBDIM) = BTH(NBG)
      BSIG(NBDIM) = BSIG(NBG)
      NBG = NBDIM
C
C     SAVE SMOOTHED BACKGROUND
C
  255 DO 260 NB = 2,NBG
      BCOUNT(NB) = BSM(NB)
      BTHET(NB) = BTH(NB)
      BSIGMA(NB) = BSIG(NB)
  260 CONTINUE
      BCOUNT(1) = (BCOUNT(3)-BCOUNT(2))/(BTHET(3)-BTHET(2))
      BCOUNT(1) = BCOUNT(1)*(BTHET(1)-BTHET(2)) + BCOUNT(2)
      BSIGMA(1) = BSIGMA(2) * 1.5
      NBG = NBG + 1
      BTHET(NBG) = TH(NS) + STEP
      BCOUNT(NBG) = (BCOUNT(NBG-1)-BCOUNT(NBG-2))/
     $              (BTHET(NBG-1)-BTHET(NBG-2))*(BTHET(NBG)-
     $              BTHET(NBG-1)) + BCOUNT(NBG-1)
      BSIGMA(NBG) = 1.5 * BSIGMA(NBG-1)
      RETURN
C
C     FORMAT STATEMENTS
C
 2000 FORMAT(1x,3H***,' DIMENSION CHECK: NUMBER OF BACKGROUND ',
     $ 'POINTS FOUND EXCEEDS',I4,'  2ND LAST BG VALUE IS AT',F7.2)
      END
      FUNCTION BG(K,L,BSIG)
C
C     PERFORM BACKGROUND - CORRECTIONS
C
      CHARACTER*1 ITIT
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(1)
      EQUIVALENCE (P(1),IP(1))
      DIMENSION BTM(2),BMG(2)
C
      IF(NBG.LE.1)  GO TO 200
      IF(K-1)  100,100,105
C----FIRST CALL, INITIALIZE
  100 NBG0 = -1
      NBG1 =  0
      NBG2 =  1
      BTM(2) = BTHET(1)
      BG2 = BCOUNT(1)
      I2 = 2
      RETURN
  200 BG = 0.
      RETURN
  105 IF (BTM(2).GT.P(L))  GO TO 150
  110 IF(NBG2+2-NBG)  112,111,150
  111 I2 = 1
  112 NBG0 = NBG0 + 1
      NBG1 = NBG1 + 1
      NBG2 = NBG2 + 1
      BTM(1) = BTM(2)
      BG1 = BG2
      BTM(2) = (BTHET(NBG1+1) + BTHET(NBG2+1)) * .5
      DO 115 I=1,I2
      B1=(BCOUNT(NBG1+I)-BCOUNT(NBG0+I))/(BTHET(NBG1+I)-BTHET(NBG0+I))
      B2=(BCOUNT(NBG2+I)-BCOUNT(NBG1+I))/(BTHET(NBG2+I)-BTHET(NBG1+I))
      B2 = (B2-B1)/(BTHET(NBG2+I)-BTHET(NBG0+I))
      BG = B2*(BTM(2)-BTHET(NBG1+I)) + B1
  115 BMG(I) = BG*(BTM(2)-BTHET(NBG0+I)) + BCOUNT(NBG0+I)
      BG2 = (BMG(1) + BMG(2))/2.
      B1 = (BCOUNT(NBG1+1)-BG1)/(BTHET(NBG1+1)-BTM(1))
      B2 = (BG2 - BCOUNT(NBG1+1))/(BTM(2)-BTHET(NBG1+1))
      IF(BTM(2).LT.P(L))  GO TO 110
  150 IF(P(L).GT.BTHET(NBG1+1)) GO TO 155
      BG = BG1 + B1*(P(L)-BTM(1))
      GO TO 160
  155 BG = BCOUNT(NBG1+1) + B2*(P(L)-BTHET(NBG1+1))
  160 BSIG = BSIGMA(NBG1)
      RETURN
      END
      FUNCTION XLPFAC (ATHETC)
	CHARACTER*1 ITIT
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(1)
      EQUIVALENCE (P(1),IP(1))
C
      COS2TH = COS(ATHETC)
      PM = (1. + POLRA*COS2TH*COS2TH) * 2.
      THETC1 = ATHETC * .5
      SINTH = SIN(THETC1)
      PP = SINTH * SINTH * COS(THETC1)
      XLPFAC = PP * (1. + POLRA) / PM
      RETURN
      END
      SUBROUTINE RBINF(IPROF)
c      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
      CHARACTER*1 ITIT,PROB
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION PROB(74),IP(1)
      EQUIVALENCE (P(1),IP(1))
C
      READ(IPROF,'(74A1)')  (PROB(I),I=1,74)
      WRITE(NTOUT,1005) (PROB(I),I=1,74)
 1005 FORMAT(1x,'BINARY PROFILE READ WITH TITLE: ',74A1)
      IF(LABEL.EQ.1) GO TO 110
C    NO TITLE READ FOR THIS JOB, USE OLD ONE
      DO 105 I=1,74
  105 ITIT(I) = PROB(I)
  110 READ(IPROF,'(3F10.4)') THMIN,THMAX,STEP
      INCP = 3
      N = 1 - INCP
c 115 N = N + INC
  115 N = N + INCP

c     READ(IPROF,END=120) P(N),P(N+1),W,P(N+2)
      READ(IPROF,1110,END=120) P(N),P(N+1),P(N+2)
 1110 FORMAT(1F9.4,1F9.0,11X,1F11.5)

CTAM  IF(EOF(IPROF)) 120,117
C----STORE SIGMA IN PROB(N+2)
  117 P(N+2) = 1./P(N+2)
      GO TO 115
  120 MAXNS = N - INCP
      RETURN
      END
      SUBROUTINE THCORR
c      COMMON /FR/ COL(80),NL(15,6),FN(20),NCHAR,KN,KL
	CHARACTER*1 ITIT
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
      DIMENSION IP(1)
      EQUIVALENCE (P(1),IP(1))
C
      WRITE(NTOUT,1000)
      DO 150 I=1,NTC
      DO 110 N=1,MAXNS,INCP
      IF(P(N)-THB(I)) 110,105,105
  105 NS = N
      GO TO 115
  110 CONTINUE
      WRITE(NTOUT,1005) I,THB(I),THE(I)
      GO TO 150
  115 DO 125 N=NS,MAXNS,INCP
      IF(P(N)-THE(I))  120,120,130
  120 P(N) = P(N) + THCR(I) + THCS(I)*P(N) + THCT(I)*P(N)*P(N)
  125 CONTINUE
  130 WRITE(NTOUT,1010) I,THB(I),THE(I),THCR(I),THCS(I),THCT(I)
  150 CONTINUE
      RETURN
 1000 FORMAT(1x,'2THETA CORRECTION'/1x,'0RANGE NO',4X,'FROM',5X,'TO',6X,
     $ '2TH = 2TH(0) +   R   +   S  ',1H*,'2TH  +  T  ',1H*,'(2TH)',
     $ 3H**2)
 1005 FORMAT(1x,I5,F12.2,F8.2,4X,'NO DATA FOR THIS RANGE')
 1010 FORMAT(1x,I5,F12.2,F8.2,16X,F8.4,F9.5,F12.5)
      END
c      FUNCTION WEIGHT(N)
      FUNCTION WEIGHT(N,COUNT,SIGM,IIII)
C****THIS ROUTINE CAN CONTAIN DIFFERENT WEIGHTING SCHEMS TO BE USED
C     TO CALCULATE THE WEIGHT FOR EACH STEP. THIS WEIGHT WILL THEN
C     WRITTEN AS THE THIRD VALUE ON EACH RECORD IN THE BINARY PROFILE
C     FILE. IT WILL BE REFERED TO AS THE $FILE$ WEIGHT IN CRYLSP.
C
      CHARACTER*1 ITIT
      COMMON IBS,IBINF,INCP,IPAGE,IPRINT,IWEIGT,LABEL,LP,
     $       MAXNS,MBG,NBG,NPOUT,NTIN,NTOUT,NERO,NTC,
     $       POLRA,PP,RDATE,RD,THMAX,THMIN,XLAMDA,STEP
      COMMON BCOUNT(50),BSIGMA(50),BTHET(50),ITIT(74),
     $       THB(10),THE(10),THCR(10),THCS(10),THCT(10),WGHT(10)
      COMMON P(40000)
C
C----SELECT WEIGHTING SCHEME
      GO TO (100,200,300),N
C
C    UNIT WEIGHT
  100 WEIGHT = 1.
      GO TO 900
C----FIRST WEIGHTING SCHEME
C----WPROWADZA 1/SIGMA**2 DLA ZLICZEN.LT.WGHT(1) I
C----WGHT(2)/SIGMA**2 DLA ZLICZEN.GE.WGHT(1)
C----W CRYLSP NALEZY DAC WAZENIE >>0<<
  200 WEIGHT = 1./SIGM
      IF(P(IIII).GE.WGHT(1)) WEIGHT=WGHT(2)/SIGM
      GO TO 900
C----SECOND WEIGHTING SCHEME
C----WPROWADZA WAGE (SIGMA**2+WGHT(1)*F**2)**(-WGHT(2))
C----SCHEMAT WAZENIA >>0<<
  300 WEIGHT = SIGM*(1./(SIGM+WGHT(1)*COUNT))**(2*WGHT(2))
  900 RETURN
      END
